module Kakimasu
  class HomeController < ::ApplicationController
    # Include neccessary helpers
    include SearchTranslationsHelper
    include CountingHelper

    def index
      # Check if user has permissions
      authorize :translation, :index?
      policy_scope(Translation)

      # Get translation percentage
      @all_keys_count = countKeys(search_for_translations('all_translation_keys'))
      @missing_translation_keys_count = countKeys(search_for_translations('missing_translations'))
      @percentage = translationPercentage(@all_keys_count, @missing_translation_keys_count)
    end
  end
end