# Sets translation key for lazy lookup or unsets it.
module SearchKeyHelper
  def lazy_lookup_key(key, path)
    path = 'app/views/' + path
    file = File.read(path)

    matches = Array.new           #All places where this key is used in given file
    locations = Array.new         #Indexes which determines where to make changes
    file_length_differential = 0  #File length difference because substitutions will change file size.

    # Finds all places where given translation key is used
    file.scan(/[=|\s][t][\s]*[(]?[\s]*['|:]#{key}/) do |c|
      matches.push [c, $~.offset(0)[0]]
    end

    matches.each do |array|
      if array.first.match /[=|\s][t][\s]*[(]?[\s]*[:]\w*/  # if translation written with : not '' then its special case
        # Key with ':key' is sustituted with "'.key'"
        index = array.first.index(/:#{key}/)
        file.slice!(array.last + index + file_length_differential, (":#{key}").length)
        file.insert(array.last + index + file_length_differential, "'.#{key}'")
        file_length_differential += ("'.#{key}'").length - (":#{key}").length
      elsif key[0] != '.'
        index = array.first.index(key)
        locations.push array.last + index + file_length_differential
      end
    end

    # Insert '.' just before key for lazy lookup
    locations.each_with_index do |location, index|
      file.insert(location + index, '.')
    end

    File.write(path, file)
  end

  def remove_lazy_lookup(key, path)
    path = 'app/views/' + path
    file = File.read(path)

    # Get rid of prefix of has lazy lookup prefix
    if key.include? '.'
      key = key.split('.').last
      key.prepend '.'
    end

    matches = Array.new    # All places where given key is used in file
    locations = Array.new  #Indexes which determintes where to make changes

    key.slice! 0 if key[0] == '.'
    file.scan(/[=|\s][t][\s]*[(]?[\s]*['][.]#{key}/) do |c|
      matches.push [c, $~.offset(0)[0]]
    end

    matches.each do |array|
      index = array.first.index('.' + key)
      locations.push array.last + index
    end

    locations.each_with_index do |location, index|
      file.slice!(location - index)    # Removes '.' from match
    end

    File.write(path, file)
  end
end