class Kakimasu.TranslationModal
  constructor: (el) ->
    @$el = $(el)
    @delegateEvents()

  delegateEvents: ->
    @$el.on 'click', '.translate-key-button', $.proxy(@fillModal, @)

  fillModal: (e) ->
    $chosenKey = $(e.currentTarget)
    $('#translation-modal-form #key').val($chosenKey.data('key'))
    $('#translation-modal-form #path').val($chosenKey.data('path'))

    $('.translation-key').text $chosenKey.data('key')
    $('.translation-key-path').text "( #{$chosenKey.data('path')} )"

    html = ''
    html += '<p id="lazy-lookup-checkbox-tag">'
    html += '<label for="Unique">Unique</label>'
    html += '<input type="checkbox" name="lazy_lookup" id="lazy_lookup" value="1"'
    if $chosenKey.data('unique')
      html += 'checked="checked"'
    html += '>'
    html += '</p>'
    $('#lazy-lookup-checkbox-tag').remove()
    $('#translation-modal-form #lazy-lookup-checkbox').append html

    translations = $chosenKey.data('translations')
    locales = $chosenKey.data('locales')

    for l, index in locales
      translation = translations[index]
      translation = translation.replace /\u0026#39;/g, "'"
      $("#translation-modal-form ##{l}").val('')
      if translation
        unless translation.match /<span.*<\/span>/
          $("#translation-modal-form ##{l}").val(translation)
          $("#translation-modal-form ##{l}").attr('name', l)
          $("#translation-modal-form ##{l}").attr('value', translation)
        else
          if translation.match /<span class='(translation-with-key).*<\/span>/
            match = /<span.*>(.*)<\/span>/i.exec translation
            $("#translation-modal-form ##{l}").val(match[1])
            $("#translation-modal-form ##{l}").attr('name', l)
            $("#translation-modal-form ##{l}").attr('value', match[1])

    # Closes collapse element if it is open
    $('.collapse').removeClass('in')
